searchNodes=[{"doc":"The main storage integration for Waffle, this acts primarily as a wrapper around Google.Api.Storage.V1 . To use this module with Waffle, simply set your :storage config appropriately: config :waffle , storage : Waffle.Storage.Google.CloudStorage Ensure you have a valid bucket set, either through the configs or as an environment variable, otherwise all calls will fail. The credentials available through Goth must have the appropriate level of access to the bucket, otherwise some (or all) calls may fail.","ref":"Waffle.Storage.Google.CloudStorage.html","title":"Waffle.Storage.Google.CloudStorage","type":"module"},{"doc":"Returns the bucket for file uploads.","ref":"Waffle.Storage.Google.CloudStorage.html#bucket/1","title":"Waffle.Storage.Google.CloudStorage.bucket/1","type":"function"},{"doc":"Constructs a new connection object with scoped authentication. If no scope is provided, the devstorage.full_control scope is used as a default.","ref":"Waffle.Storage.Google.CloudStorage.html#conn/1","title":"Waffle.Storage.Google.CloudStorage.conn/1","type":"function"},{"doc":"Delete a file from a Google Cloud Storage bucket.","ref":"Waffle.Storage.Google.CloudStorage.html#delete/3","title":"Waffle.Storage.Google.CloudStorage.delete/3","type":"function"},{"doc":"A wrapper for Waffle.Definition.Versioning.resolve_file_name/3 .","ref":"Waffle.Storage.Google.CloudStorage.html#fullname/3","title":"Waffle.Storage.Google.CloudStorage.fullname/3","type":"function"},{"doc":"Returns the full file path for the upload destination.","ref":"Waffle.Storage.Google.CloudStorage.html#path_for/3","title":"Waffle.Storage.Google.CloudStorage.path_for/3","type":"function"},{"doc":"Put a Waffle file in a Google Cloud Storage bucket.","ref":"Waffle.Storage.Google.CloudStorage.html#put/3","title":"Waffle.Storage.Google.CloudStorage.put/3","type":"function"},{"doc":"Returns the storage directory within a bucket to store the file under.","ref":"Waffle.Storage.Google.CloudStorage.html#storage_dir/3","title":"Waffle.Storage.Google.CloudStorage.storage_dir/3","type":"function"},{"doc":"Retrieve the public URL for a file in a Google Cloud Storage bucket. Uses Waffle.Storage.Google.UrlV2 by default, which uses v2 signing if a signed URL is requested, but this can be overriden in the options list or in the application configs by setting :url_builder to any module that imlements the behavior of Waffle.Storage.Google.Url .","ref":"Waffle.Storage.Google.CloudStorage.html#url/4","title":"Waffle.Storage.Google.CloudStorage.url/4","type":"function"},{"doc":"","ref":"Waffle.Storage.Google.CloudStorage.html#t:object_or_error/0","title":"Waffle.Storage.Google.CloudStorage.object_or_error/0","type":"type"},{"doc":"","ref":"Waffle.Storage.Google.Token.DefaultFetcher.html","title":"Waffle.Storage.Google.Token.DefaultFetcher","type":"module"},{"doc":"","ref":"Waffle.Storage.Google.Token.Fetcher.html","title":"Waffle.Storage.Google.Token.Fetcher","type":"behaviour"},{"doc":"","ref":"Waffle.Storage.Google.Token.Fetcher.html#c:get_token/1","title":"Waffle.Storage.Google.Token.Fetcher.get_token/1","type":"callback"},{"doc":"Defines an interface for generating Google Cloud Storage URLs.","ref":"Waffle.Storage.Google.Url.html","title":"Waffle.Storage.Google.Url","type":"behaviour"},{"doc":"Constructs a URL based on data from Waffle.","ref":"Waffle.Storage.Google.Url.html#c:build/4","title":"Waffle.Storage.Google.Url.build/4","type":"callback"},{"doc":"This is an implementation of the v2 URL signing for Google Cloud Storage. See the Google documentation for more details. The bulk of the major logic is taken from Martide's arc_gcs work: https://github.com/martide/arc_gcs .","ref":"Waffle.Storage.Google.UrlV2.html","title":"Waffle.Storage.Google.UrlV2","type":"module"},{"doc":"Same as build(definition, version, meta, []) .","ref":"Waffle.Storage.Google.UrlV2.html#build/3","title":"Waffle.Storage.Google.UrlV2.build/3","type":"function"},{"doc":"Returns the remote asset host. The config key is assumed to be :asset_host .","ref":"Waffle.Storage.Google.UrlV2.html#endpoint/1","title":"Waffle.Storage.Google.UrlV2.endpoint/1","type":"function"},{"doc":"Returns the amount of time, in seconds, before a signed URL becomes invalid. Assumes the key for the option is :expires_in .","ref":"Waffle.Storage.Google.UrlV2.html#expiry/1","title":"Waffle.Storage.Google.UrlV2.expiry/1","type":"function"},{"doc":"Determines whether or not the URL should be signed. Assumes the key for the option is :signed .","ref":"Waffle.Storage.Google.UrlV2.html#signed?/1","title":"Waffle.Storage.Google.UrlV2.signed?/1","type":"function"},{"doc":"A collection of utility functions.","ref":"Waffle.Storage.Google.Util.html","title":"Waffle.Storage.Google.Util","type":"module"},{"doc":"Attempts to return a value from a given options list, using the application configs as a back-up. The application (used in Application.get_env/3 ) is assumed to be :waffle . This assumes that the application environment is set using waffle as the application name. If the value is not found in any of those location, an optional default value can be returned.","ref":"Waffle.Storage.Google.Util.html#option/3","title":"Waffle.Storage.Google.Util.option/3","type":"function"},{"doc":"If the given string does not already start with a forward slash, this function will prepend one and return the result. Examples &gt; prepend_slash ( &quot;some/path&quot; ) &quot;/some/path&quot; &gt; prepend_slash ( &quot;/im/good&quot; ) &quot;/im/good&quot;","ref":"Waffle.Storage.Google.Util.html#prepend_slash/1","title":"Waffle.Storage.Google.Util.prepend_slash/1","type":"function"},{"doc":"The function Objects.storage_objects_insert/4 has the wrong URL and will always fail to perform an upload. Because these clients are automatically generated, there needs to be an investigation as to why this URL is being incorrectly set before a solution can be applied. This version of the function is an exact copy/paste of the official function except that it uses the correct upload URL.","ref":"Waffle.Storage.Google.Util.html#storage_objects_insert/4","title":"Waffle.Storage.Google.Util.storage_objects_insert/4","type":"function"},{"doc":"Accepts four forms of variables: The tuple {:system, key} , which uses System.get_env/1 . The tuple {:app, key} , which uses Application.get_env/2 . The tuple {:app, app, key} , which usees Application.get_env/2 . Anything else which is returned as-is. In the second form ( {:app, key} ), the application is assumed to be :waffle although this can be overriden using the third form ( {:app, app, key} ).","ref":"Waffle.Storage.Google.Util.html#var/1","title":"Waffle.Storage.Google.Util.var/1","type":"function"},{"doc":"This is hack until Waffle declares formal typespecs in its own project.","ref":"Waffle.Types.html","title":"Waffle.Types","type":"module"},{"doc":"","ref":"Waffle.Types.html#t:definition/0","title":"Waffle.Types.definition/0","type":"type"},{"doc":"","ref":"Waffle.Types.html#t:file/0","title":"Waffle.Types.file/0","type":"type"},{"doc":"","ref":"Waffle.Types.html#t:meta/0","title":"Waffle.Types.meta/0","type":"type"},{"doc":"","ref":"Waffle.Types.html#t:version/0","title":"Waffle.Types.version/0","type":"type"}]